unit registerunit;

interface

uses ActiveX;

function DllRegisterServer: HResult;
function DllUnregisterServer: HResult;
function DllGetClassObject(const CLSID, IID: TGUID; var Obj): HResult; stdcall;
function DllCanUnloadNow: HResult; stdcall;

//Export the functions for registration
exports
   DllRegisterServer,DllUnregisterServer,
   DllGetClassObject, DllCanUnloadNow;

//Add any type library file in here to be linked in.

{$R Demoauto.tlb}

implementation
uses Registraunit;

function DllGetClassObject(const CLSID, IID: TGUID; var Obj): HResult;
const CLASS_E_CLASSNOTAVAILABLE = $80040111;
begin
  Pointer(Obj) := nil;
  Result := CLASS_E_CLASSNOTAVAILABLE;
end;

function DllCanUnloadNow: HResult;

begin
  Result := S_FALSE;
end;

function DllRegisterServer: HResult;
begin
 Result := UpdateRegistryLib(true, ModuleFileName);
end;

function DllUnregisterServer: HResult;
begin
  Result  := UpdateRegistryLib(false ,ModuleFileName);
end;

end.
